 /*
  * Khoros: $Id$
  */

 /*
  * $Log$
  */

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1991, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as to the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including, for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1991 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: vrdclust.h
 >>>>            Author: 
 >>>> Date Last Updated: Wed Aug  7 09:39:02 1991
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _vrdclust_h_
#define _vrdclust_h_

#include "vinclude.h"


/* -include_includes */
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program,	/* a pointer to the program name argv[0] */
	*calloc();
int	ac;

/****************************************************************
*
*                    vrdclust Argument Structure
*
****************************************************************/

typedef struct _vrdclust  {

/*
 *  input image (Required infile)
 */
char	*i_file;	/* input image FILENAME */
int	 i_flag;	/* input image FLAG */

/*
 *  resulting output image (Required outfile)
 */
char	*o_file;	/* resulting output image FILENAME */
int	 o_flag;	/* resulting output image FLAG */

/*
 *  the final number of clusters (Required integer)
 */
int	 v_int; 	/* the final number of clusters INT */
int	 v_flag;	/* the final number of clusters FLAG */

/*
 *  scale the mean vectors (Required logical)
 */
int	 scale_logic;	/* scale the mean vectors LOGIC */
int	 scale_flag;  	/* scale the mean vectors FLAG */

/*
 *  select global scaling (Required logical)
 */
int	 g_logic;	/* select global scaling LOGIC */
int	 g_flag;  	/* select global scaling FLAG */

/*
 *  calculate histogram (Required logical)
 */
int	 h_logic;	/* calculate histogram LOGIC */
int	 h_flag;  	/* calculate histogram FLAG */

/*
 * merging algorithm (Required string toggle - )
 */
char	*alg_toggle;		/* merging algorithm STRING TOGGLE */
int	 alg_flag;		/* merging algorithm FLAG */

}  vrdclust_struct;

vrdclust_struct *vrdclust;

/* -include_additions */
/* -include_additions_end */

/* -include_macros */
/* -include_macros_end */

#endif
